<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>Kayla Campbell PHP Form Page</title>
    <?php include'header.php'?>
    <style>
        .error {color: rgb(221, 12, 12);}
        table.center { margin-left: auto; margin-right: auto; border: 2px dashed #453984; padding: 20px; background-color: rgb(146, 200, 213); }
        table.center td { padding: 10px; }
    </style>
</head>
<body style="background-color: rgb(145, 184, 191);">
    <h3 style="text-align: center;">Character Creation</h3>
    <p style="background-color: rgb(124, 208, 234); width: 600px; margin: 0 auto; text-align: center;">
        This page will be a form for submitting your DND 5e character for a campaign. <br>The DM will receive inputs.
    </p>

    <?php
    $errorname = $errorcharname = $errorchargender = $errorcharclass = $errorcharrace = $errorbackstory = $errorfname = 
    $errorflast = $errorstats = $errormdy = $erroravday = "";
    $fname = $ccname = $flast = $backstory = $cgender = $cclass = $crace = $backstory = $stats = $avday = "";

    $month = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
    $day = range(1, 31);
    $year = range(1910, date("Y"));
    //posts to server
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        $fname = $_POST["fname"];
        $flast = $_POST["flast"];
        $ccname = $_POST["ccname"];
        $cgender = $_POST["cgender"];
        $cclass = $_POST["cclass"];
        $crace = $_POST["crace"];
        $backstory = $_POST["backstory"];
        $stats = isset($_POST['stats']) ? $_POST['stats'] : [];
        $month = $_POST["month"];
        $day = (int)$_POST["day"];
        $year = (int)$_POST["year"];
        $avday = isset($_POST ['avday']) ? $_POST['avday'] : [];
        
        //stats must be numbers two digits or less. Operator || means or and allows for checks of valid numbers. 
        $valid_stats = true;
        foreach($stats as $stat){
            if(!is_numeric($stat) || $stat < 0 || $stat > 24) {$valid_stats = false; break;}
        }

        // Check if required fields are filled, condition. Should no longer be a necessary part of the code as I've added required fields instead. 
        $errors = [];
        if ($_POST['fname'] == '') {$error = "You must fill in your first name.";}
        if ($_POST['flast'] == '') {$error = "You must fill in your last name.";}
        if ($_POST['ccname'] == ''){$error = "You must fill in your character's name.";}
        if ($_POST['cgender'] == ''){$error = "You must fill in your last name.";}
        if ($_POST['cclass'] == ''){$error = "You must fill in your last name.";}
        if ($_POST['crace'] == ''){$error = "You must fill in your last name.";}
        if ($_POST['backstory'] == ''){$error = "You must fill in your last name.";}
        if ($_POST['stats'] == ''){$error = "You must fill in your last name.";}
        if (empty($month)) {
            $errors['mdy'] = "Month is required.";
        } elseif (empty($day)) {
            $errors['mdy'] = "Day is required.";
        } elseif (empty($year)) {
            $errors['mdy'] = "Year is required.";
        }
        if ($_POST['avday'] == ''){$error = "You must choose one or more days";
        }
        
// if no errors returned, submit the form. 
        if(!empty($errors)){
            foreach ($errors as $error){
                echo "$errors";
            }}
            else {
                include 'submitted_form.php';
                exit();
            }
    }



        ?>
<!--table for the form-->
<form method="post" action="submitted_form.php">
    <table class = "center">
            <tr>
                <td>First name:<span class="error">* <?php echo $errors['fname'] ?? ''; ?></span></td>
                <td><input type="text" name="fname" required value="<?php echo htmlspecialchars($fname); ?>"></td>
            </tr>
            <tr>
                <td>Last name:<span class="error">* <?php echo $errors['flast'] ?? ''; ?></span></td>
                <td><input type="text" name="flast" required value="<?php echo htmlspecialchars($flast); ?>"></td>
            </tr>
            <tr>
                <td>Birth date:<span class="error">* <?php echo $errors['mdy'] ?? ''; ?></span></td>
                <td>
                    Month:
                    <select name="month" required>
                        <option value="">Month</option>
                        <?php foreach ($month as $m): ?>
                            <option value="<?php echo $m; ?>" <?php if ($month == $m) echo "selected"; ?>><?php echo $m; ?></option>
                        <?php endforeach; ?>
                    </select>
                    Day:
                    <select name="day" required>
                        <option value="">Day</option>
                        <?php foreach ($day as $d): ?>
                            <option value="<?php echo $d; ?>" <?php if ($day == $d) echo "selected"; ?>><?php echo $d; ?></option>
                        <?php endforeach; ?>
                    </select>
                    Year:
                    <select name="year" required>
                        <option value="">Year</option>
                        <?php foreach ($year as $y): ?>
                            <option value="<?php echo $y; ?>" <?php if ($year == $y) echo "selected"; ?>><?php echo $y; ?></option>
                        <?php endforeach; ?>
                    </select>
                </td>
            </tr>
            <tr>
                <td>Character name:<span class="error">* <?php echo $errors['ccname'] ?? ''; ?></span></td>
                <td><input type="text" name="ccname" required value="<?php echo htmlspecialchars($ccname); ?>"></td>
            </tr>
            <tr>
                <td>Gender:<span class="error">* <?php echo $errors['cgender'] ?? ''; ?></span></td>
                <td>
                    <?php $genderoptions = ['female', 'male', 'nonbinary', 'transman', 'transwoman']; ?>
                    <?php foreach ($genderoptions as $option): ?>
                        <input type="radio" name="cgender" value="<?php echo $option; ?>" <?php if ($cgender == $option) echo 'checked'; ?> required> <?php echo ucfirst($option); ?>
                    <?php endforeach; ?>
                </td>
            </tr>
            <tr>
                <td>Class choice:<span class="error">* <?php echo $errors['cclass'] ?? ''; ?></span></td>
                <td>
                    <select name="cclass" required>
                        <option value="rogue" <?php if ($cclass == 'rogue') echo 'selected'; ?>>Rogue</option>
                        <option value="ranger" <?php if ($cclass == 'ranger') echo 'selected'; ?>>Ranger</option>
                        <option value="paladin" <?php if ($cclass == 'paladin') echo 'selected'; ?>>Paladin</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td>Character Race:<span class="error">* <?php echo $errors['crace'] ?? ''; ?></span></td>
                <td>
                    <select name="crace" required>
                        <option value="elf" <?php if ($crace == 'elf') echo 'selected'; ?>>Elf</option>
                        <option value="human" <?php if ($crace == 'human') echo 'selected'; ?>>Human</option>
                        <option value="dwarf" <?php if ($crace == 'dwarf') echo 'selected'; ?>>Dwarf</option>
                        <option value="half-elf" <?php if ($crace == 'half-elf') echo 'selected'; ?>>Half-Elf</option>
                        <option value="orc" <?php if ($crace == 'orc') echo 'selected'; ?>>Orc</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td>Backstory:<span class="error">* <?php echo $errorbackstory;?></span></td><!--span class error shows requirement as asterisk next to field label-->
                <td>
                    <textarea name="backstory" rows="5" cols="50"><?php echo htmlspecialchars($backstory); ?></textarea>
                    <!--This is submitted for the DM only, does not display on submitted page-->
                </td>
            </tr>
            <tr>
                <td>Stats:<span class="error">* <?php echo $errorstats;?></span> Between 1-24 </td><!--array-->
                <td>
                    Strength:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[0] ?? ''); ?>">&nbsp;&nbsp;     
                    Dexterity:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[1] ?? ''); ?>"> &nbsp;&nbsp;    
                       
                    Wisdom:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[2] ?? ''); ?>">&nbsp;&nbsp;  
                    Intelligence:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[3] ?? ''); ?>">&nbsp;&nbsp;
                    Constitution:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[4] ?? ''); ?>">&nbsp;&nbsp;
                    Charisma:<input type="number" name="stats[]" value="<?php echo htmlspecialchars($stats[5] ?? ''); ?>">
                    <!--This array needs work for forcing an error if it's outside of range. -->
                </td>
            </tr>
            <tr> <!-- check boxes for availability, array, operator ? used for evaluating true or false against conditions ? true : false-->
                <td>What days are you available to play?<span class="error">* <?php echo !empty($errors) && in_array("You must choose one or more days.", $errors) ? "You must choose one or more days." : ""; ?></span></td>
                <td>
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Monday" <?php if (isset($days) && in_array('Monday', $days)) echo 'checked'; ?>> Mondays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Tuesday" <?php if (isset($days) && in_array('Tuesday', $days)) echo 'checked'; ?>> Tuesdays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Wednesday" <?php if (isset($days) && in_array('Wednesday', $days)) echo 'checked'; ?>> Wednesdays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Thursday" <?php if (isset($days) && in_array('Thursday', $days)) echo 'checked'; ?>> Thursdays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Friday" <?php if (isset($days) && in_array('Friday', $days)) echo 'checked'; ?>> Fridays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Saturday" <?php if (isset($days) && in_array('Saturday', $days)) echo 'checked'; ?>> Saturdays
                    <input type="checkbox" id="weekday[]" name="avday[]" value="Sunday" <?php if (isset($days) && in_array('Sunday', $days)) echo 'checked'; ?>> Sundays
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <input type="submit" name="Submit" value="Submit button">
                </td>
            </tr>
        </form>
      </table>

    

    <?php include 'footer.php'; ?> <!-- footer include -->
</body>
<!-- As a note, this code got so messy and I don't have time to start over and verify only what is needed. I ended up having to wipe my PC this weekend, and sometimes I remove things and then the table disappears, or the text box moves widly and I don't have time to chase down these bugs, so apologies for the unnecessary bits.  -->