<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Submitted Character page</title>
    <style>
        .error {color: rgb(221, 12, 12);}
        table.center { margin-left: auto; margin-right: auto; border: 2px dashed #453984; padding: 20px; background-color: rgb(146, 200, 213); }
        table.center td { padding: 10px; }
    </style>
</head>
<body style="background-color: rgb(145, 184, 191);">
<?php include 'header.php'; ?> <!-- header-->
    <h3 style="text-align: center;">Character Submission</h3>

    <?php
   
   //retrieves from submission
   if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $fname = isset($_POST["fname"]) ? $_POST["fname"] : '';
    $flast = isset($_POST["flast"]) ? $_POST["flast"] : '';
    $ccname = isset($_POST["ccname"]) ? $_POST["ccname"] : '';
    $cgender = isset($_POST["cgender"]) ? $_POST["cgender"] : '';
    $cclass = isset($_POST["cclass"]) ? $_POST["cclass"] : '';
    $crace = isset($_POST["crace"]) ? $_POST["crace"] : '';
    $backstory = isset($_POST["backstory"]) ? $_POST["backstory"] : '';
    $stats = isset($_POST['stats']) ? $_POST['stats'] : [];
    $month = isset($_POST["month"]) ? $_POST["month"] : 0;
    $day = isset($_POST["day"]) ? (int)$_POST["day"] : 0;
    $year = isset($_POST["year"]) ? (int)$_POST["year"] : 0;
    $avday = isset($_POST ['avday']) ? $_POST['avday'] : [];

        //gender assign for cumulative response, condition
     $pronoun = '';
     $pronoun2  = '';
       
        if ($cgender == "male") {
            $pronoun = "he"; 
            $pronoun2 = "his";
        }
        elseif ($cgender == "female"){
            $pronoun = "she"; 
            $pronoun2 = "her";
        }
        elseif ($cgender == "nonbinary"){
            $pronoun = "they"; 
            $pronoun2 = "their";
        }
        elseif ($cgender == "transman"){
            $pronoun = "he"; 
            $pronoun2 = "his";
        }
        elseif ($cgender == "transwoman"){
            $pronoun = "she"; 
            $pronoun2 = "her";
        }
        

        // Check if required fields are filled, condition
       if (isset($_POST['stats'])){
        $stats = $_POST['stats'];
       } else {$stats = [];

       }
       if (isset($_POST['avday'])){
        $avday = $_POST['avday'];
       } else {$avday = [];

       }}
       
//check for errors. Errors should not be able to make it to this side as I have added the requirement option to the fields. 
        $errors = [];
        if (empty($fname)) $errors[] = "First name is required.";
        if (empty($flast)) $errors[] = "Last name is required.";
        if (empty($ccname)) $errors[] = "Character name is required.";
        if (empty($cgender)) $errors[] = "Gender is required.";
        if (empty($cclass)) $errors[] = "Class is required.";
        if (empty($crace)) $errors[] = "Race is required.";
        if (empty($backstory)) $errors[] = "Backstory is required.";
        if (empty($stats)) $errors[] = "Stats are required.";
        if (empty($month) || empty($day) || empty($year)) $errors[] = "Valid date of birth is required.";
        if (empty($avday)) $errors[] = "At least one day is required.";

        
        


        //display submissions: 
        if (empty($errors)) {
            echo "<p>Congratulations, $fname $flast, on submitting your character, $ccname! </p>";
            echo "<p>$pronoun is ready to play as a $crace $cclass with the stats:</p>";
            
            echo "<ul>";
            echo "<li>Dexterity:" . htmlspecialchars($stats[1]) . "</li>";
            echo "<li>Wisdom:" . htmlspecialchars($stats[2]) . "</li>";
            echo "<li>Intelligence:" . htmlspecialchars($stats[3]) . "</li>";
            echo "<li>Constitution:" . htmlspecialchars($stats[4]) . "</li>";
            echo "<li>Charisma:" . htmlspecialchars($stats[5]) . "</li>";
            echo "</ul>";
            echo "<p>Date of Birth: $month-$day-$year</p>";}
               
            

           //I kept running into issues with the dates available returning here
// foreach loop            if (!empty($days)){
           echo "<p>$fname is available on: </p><ul>"; 
           if(!empty($avday)){
            foreach ($avday as $avaday) {
                echo "<li>" . htmlspecialchars($avaday) . "</li>";
            }
        }
            echo "</ul>";
        
        if (!empty($errors)) {
            echo "<p class='error'>The following errors were found:</p>";
            echo "<ul class='error'>";
            foreach ($errors as $error) {
                echo "<li>" . htmlspecialchars($error) . "</li>";
            }
            echo "</ul>";}    
    ?>
<!-- posts from form-->
    <form action="index.php" method="post">
        <input type="hidden" name="fname" value="<?php echo htmlspecialchars($fname); ?>">
        <input type="hidden" name="flast" value="<?php echo htmlspecialchars($flast); ?>">
        <input type="hidden" name="ccname" value="<?php echo htmlspecialchars($ccname); ?>">
        <input type="hidden" name="cgender" value="<?php echo htmlspecialchars($cgender); ?>">
        <input type="hidden" name="cclass" value="<?php echo htmlspecialchars($cclass); ?>">
        <input type="hidden" name="crace" value="<?php echo htmlspecialchars($crace); ?>">
        <input type="hidden" name="backstory" value="<?php echo htmlspecialchars($backstory); ?>">
        <?php foreach ($stats as $stat): ?>
            <input type="hidden" name="stats[]" value="<?php echo htmlspecialchars($stat); ?>">
        <?php endforeach; ?>
        <input type="hidden" name="month" value="<?php echo htmlspecialchars($month); ?>">
        <input type="hidden" name="day" value="<?php echo htmlspecialchars($day); ?>">
        <input type="hidden" name="year" value="<?php echo htmlspecialchars($year); ?>">
        <?php foreach ($avday as $avaday): ?>
            <input type="hidden" name="avday[]" value="<?php echo htmlspecialchars($avday); ?>">
        <?php endforeach; ?>
        <input type="submit" value="Go Back and Fix Errors">
    </form>

    <?php include 'footer.php'; ?> <!-- footer displayed-->
</body>
</html>